using System;
class Program
{
    static void Main(string[] args)
    {
        int t=int.Parse(Console.ReadLine());
        string[] s = Console.ReadLine().Split();
        int n = int.Parse(s[0]);
        int k=int.Parse(s[1]);

        string[] s2 = Console.ReadLine().Split();
        int[] pregledi=new int[n];
        for (int i = 0; i < n; i++)
        {
            pregledi[i]=int.Parse(s2[i]);
        }

        int uvazenost = 0;

        for(int i=0;  i < n; i++)
        {
            if (uvazenost <= pregledi[i])
            {
                uvazenost++;
            }
            else uvazenost--;
        }
        if(uvazenost==k)
        {
            Console.WriteLine("DA");

            for(int i=0; i < n;i++)
            {
                Console.Write(pregledi[i]+" ");
            }
        }
        else
        { Console.WriteLine("NE"); }
    }
}